'''
If 3 people vote someone as a freekiller then the vote pops up and asks everyone to vote if the Ct has freekilled.
'''

import es, gamethread, usermsg, playerlib, popuplib, cmdlib
import sqlite3, time



info = es.AddonInfo() 
info['name']        = "Freekiller"
info['version']     = "3.2.5" 
info['author']      = "DanielB" 
info['url']         = "http://www.customsource.info" 
info['description'] = "Freekiller Script for Fire" 

killCount = {} # {userid: {time: float, kills:int}}

graceTime = 2
maxKills = 3

map_FreeKillers = {} # {steamid: int_marks}
map_votemute = {} # {steamid: int_marks}
round_voted = []

addon_name = 'freekiller'
activeVote = False

admins = ['STEAM_0:1:20684450', 'STEAM_ID_LAN']

class FreeKillVote:
    def __init__(self, freekiller):
        self.freekiller = es.getuserid(freekiller)
        self.killerSteam = freekiller
        self.killername = cVotes_fk[freekiller]['name']
        self.voted = []
        self.votes = []
        self.active = True
        self.started = time.time()
        self.genPop()
        self.startHUD()
        gamethread.delayedname(25, 'freekiller_voteend', self.endVote)
        msg('Is %s a Freekiller?'%self.killername)
        
        
    def genPop(self):
        if popuplib.exists('freekiller_votes'): popuplib.delete('freekiller_votes')
        p = popuplib.easymenu('freekiller_votes', None, self.callback)
        p.settitle('Is %s a Free Killer?'%self.killername)
        p.addoption('yes', 'Yes')
        p.addoption('no', 'No')
        
        unvoted = filter(lambda x: not x in self.voted, es.getUseridList())
        unvoted = filter(lambda x: es.getplayerteam(x) in (2,3), unvoted)
        for userid in unvoted:
            p.send(userid)
            
    def callback(self, userid, choice, popupname):
        global map_FreeKillers
        if self.active:
            self.voted.append(userid)
            self.votes.append(choice == 'yes')
            
            humans = filter(lambda x: not es.isbot(x), es.getUseridList())
            if len(self.voted) == len(humans):
                self.endVote()
                    
        else:
            if popuplib.exists('freekiller_votes'): popuplib.delete('freekiller_votes')
    
    def endVote(self):
        global activeVote, cVotes_fk
        
        round_voted.append(self.killerSteam)
        
        activeVote = False
        gamethread.cancelDelayed('freekiller_voteend')
        self.active = False
        yesCount = len(filter(lambda x: x, self.votes))
        voteCount = len(self.votes) 
        #isFreeKiller = yesCount > voteCount-yesCount
        p60 = int(voteCount * 0.6)
        #isFreeKiller = float(yesCount)/voteCount > 60
        isFreeKiller = yesCount > p60
        
        if isFreeKiller:
            try:
                playerlib.getPlayer(self.freekiller).slay()
            except:
                pass
                
            msg('%s has been voted to be a free killer!'%self.killername)
            
            if self.killerSteam in map_FreeKillers:
                map_FreeKillers[self.killerSteam] += 1
            else:
                map_FreeKillers[self.killerSteam] = 1
                
            if map_FreeKillers[self.killerSteam] >= 2:
                #es.changeteam(self.freeKiller, '2')
                if es.getplayerteam(self.freekiller) != 2:
                    es.delayed(1, 'est_team %s 2'%self.freekiller)
                msg('%s cannot be a CT again this map!'%self.killername)
                
            
            database.addMark(self.killerSteam, self.killername)    
        
        else:
            #msg('y: %s, n: %s, t: %s'%(yesCount, voteCount-yesCount, voteCount))
            msg('%s is not a free killer!'%es.getplayername(self.freekiller))
            
        if self.killerSteam in cVotes_fk:
            del cVotes_fk[self.killerSteam]
            
        self.cleanup()
            
    def startHUD(self):
        if self.active:
            yes = len(filter(lambda x: x, self.votes))
            no = len(self.votes) - yes
            timeleft = 25 - int(time.time() - self.started)
            text = 'FreeKiller Vote\nIs %s a Free Killer?\nYes - %s\nNo - %s\nTime Left: %s'%(self.killername, yes, no, timeleft)
            usermsg.hudhint('#all', text)
            gamethread.delayedname(1, 'freekiller_hud', self.startHUD)
        
    def stopHUD(self):
        gamethread.cancelDelayed('freekiller_hud')
    
    def cleanup(self):
        gamethread.cancelDelayed('freekiller_voteend')
        self.active = False
        self.stopHUD()
        if popuplib.exists('freekiller_votes'):
            popuplib.delete('freekiller_votes')
            
class VoteMute:
    def __init__(self, steamid):
        self.userid = es.getuserid(steamid)
        self.steamid = steamid
        self.name =  cVotes_m[steamid]['name']
        self.voted = []
        self.votes = []
        self.active = True
        self.started = time.time()
        self.genPop()
        self.startHUD()
        gamethread.delayedname(25, 'votemute_voteend', self.endVote)
        msg('Mute %s?'%self.name)
        
        
    def genPop(self):
        if popuplib.exists('motemute_votes'): popuplib.delete('motemute_votes')
        p = popuplib.easymenu('motemute_votes', None, self.callback)
        p.settitle('Mute %s?'%self.name)
        p.addoption('yes', 'Yes')
        p.addoption('no', 'No')
        
        unvoted = filter(lambda x: not x in self.voted, es.getUseridList())
        unvoted = filter(lambda x: es.getplayerteam(x) in (2,3), unvoted)
        for userid in unvoted:
            p.send(userid)
            
    def callback(self, userid, choice, popupname):
        global map_votemute
        if self.active:
            self.voted.append(userid)
            self.votes.append(choice == 'yes')
            
            humans = filter(lambda x: not es.isbot(x), es.getUseridList())
            if len(self.voted) == len(humans):
                self.endVote()
                    
        else:
            if popuplib.exists('userid_votes'): popuplib.delete('userid_votes')
    
    def endVote(self):
        global activeVote, cVotes_m
        self.stopHUD()
        
        activeVote = False
        gamethread.cancelDelayed('votemute_voteend')
        self.active = False
        yesCount = len(filter(lambda x: x, self.votes))
        voteCount = len(self.votes) 
        p60 = int(voteCount * 0.6)
        
        if yesCount > p60:
            database.addMuteMark(self.steamid, self.name)
            gamethread.cancelDelayed('votemute_mute_%s'%self.userid)
            mute(self.userid)
            
            msg('%s has been muted!'%self.name)
            
            if self.steamid in map_votemute:
                map_votemute[self.steamid] += 1
            else:
                map_votemute[self.steamid] = 1
                
            if map_votemute[self.steamid] >= 2:
                msg('%s has been muted for the rest of this map this map!'%self.name)
            else:
                gamethread.delayedname(60*5, 'votemute_mute_%s'%self.userid, unmute, self.userid)
        
        else:
            msg('%s will not be muted!'%es.getplayername(self.userid))
            
        if self.steamid in cVotes_m:
            del cVotes_m[self.steamid]
            
        self.cleanup()
            
    def startHUD(self):
        if self.active:
            yes = len(filter(lambda x: x, self.votes))
            no = len(self.votes) - yes
            timeleft = 25 - int(time.time() - self.started)
            text = 'VoteMute\nMute %s?\nYes - %s\nNo - %s\nTime Left: %s'%(self.name, yes, no, timeleft)
            usermsg.hudhint('#all', text)
            gamethread.delayedname(1, 'votemute_hud', self.startHUD)
        
    def stopHUD(self):
        gamethread.cancelDelayed('votemute_hud')
    
    def cleanup(self):
        gamethread.cancelDelayed('votemute_voteend')
        self.active = False
        self.stopHUD()
        if popuplib.exists('votemute_voteend'):
            popuplib.delete('votemute_voteend')
            
class Database:
    def __init__(self):
        self.connection = sqlite3.connect(es.getAddonPath(addon_name) + '/marks.sqlite3')
        self.connection.text_factory = str
        self.cursor = self.connection.cursor()
        self.createTable()
    def createTable(self):
        self.cursor.execute('CREATE TABLE IF NOT EXISTS marks (steamid TEXT PRIMARY KEY, name TEXT, count INTEGER)')
        self.cursor.execute('CREATE TABLE IF NOT EXISTS mute (steamid TEXT PRIMARY KEY, name TEXT, count INTEGER)')

    def close(self, save=False):
        if save: self.commit()
        self.connection.close()
        
    def commit(self):
        self.connection.commit()
        es.dbgmsg(0, 'Saved FreeKiller-VoteMute database')

    def execute(self, query):
        self.cursor.execute(query)
    def fetchone(self, query):
        self.execute(query)
        return self.cursor.fetchone()
    def fetchall(self, query):
        self.execute(query)
        return self.cursor.fetchall()
    def fetchmany(self, number, query):
        self.execute(query)
        return self.cursor.fetchmany(number)
        
        
    def _getMuteMarks(self, steamid):
        marks = self.fetchone('SELECT count FROM mute WHERE steamid="%s"'%steamid)
        indb = bool(marks)
        if indb:
            return marks[0]
        return None
        
    def addMuteSteam(self, steamid, name='Unknown', marks=0):
        #self.execute('DELETE FROM mute WHERE steamid="%s"'%steamid)
        self.execute('INSERT INTO mute VALUES ("%s", "%s", %s)'%(steamid, name, marks))
        
    def addMuteMark(self, steamid, name='Unknown'):
        marks = self._getMuteMarks(steamid)
        if marks is None:
            #self.execute('INSERT INTO marks VALUES ("%s", "%s", 1)'%(steamid, name))
            self.addMuteSteam(steamid, name, '1')
        else:
            marks += 1
            self.execute('UPDATE mute SET count=%s WHERE steamid="%s"'%(marks, steamid))
            
    def subMuteMark(self, steamid):
        marks = self._getMuteMarks(steamid)
        if marks is None:
            self.execute('INSERT INTO mute VALUES ("%s", "%s", 0)'%(steamid, name))
        else:
            marks -= 1
            self.execute('UPDATE mute SET count=%s WHERE steamid="%s"'%(marks, steamid))
    
    def removeMuteSteam(self, steamid):
        self.execute('DELETE FROM mute WHERE steamid="%s"'%steamid)
        
    def getMuteMarks(self, steamid):
        marks = self.fetchone('SELECT count FROM mute WHERE steamid="%s"'%steamid)
        if marks:
            try:
                return marks[0]
            except:
                return marks
        return 0
        
    def getMuteInfo(self, steamid):
        return self.fetchone('SELECT name, count FROM mute WHERE steamid="%s"'%steamid)
        
        
    def getName(self, steamid):
        x = self.fetchone('SELECT name FROM mute WHERE steamid="%s"'%steamid)
        if x:
            return x[0]
        x = self.fetchone('SELECT name FROM marks WHERE steamid="%s"'%steamid)
        if x:
            return x[0]
        return 'Unknown'
    
    def _getMarks(self, steamid):
        marks = self.fetchone('SELECT count FROM marks WHERE steamid="%s"'%steamid)
        indb = bool(marks)
        if indb:
            return marks[0]
        return None
        
    def addSteam(self, steamid, name='Unknown', marks=0):
        self.execute('DELETE FROM marks WHERE steamid="%s"'%steamid)
        self.execute('INSERT INTO marks VALUES ("%s", "%s", %s)'%(steamid, name, marks))
        
    def addMark(self, steamid, name='Unknown'):
        marks = self._getMarks(steamid)
        if marks is None:
            #self.execute('INSERT INTO marks VALUES ("%s", "%s", 1)'%(steamid, name))
            self.addSteam(steamid, name, '1')
        else:
            marks += 1
            self.execute('UPDATE marks SET count=%s WHERE steamid="%s"'%(marks, steamid))
            
            
            
    def removeSteam(self, steamid):
        self.execute('DELETE FROM marks WHERE steamid="%s"'%steamid)
            
    def subMark(self, steamid):
        marks = self._getMarks(steamid)
        if marks is None:
            self.execute('INSERT INTO marks VALUES ("%s", "%s", 0)'%(steamid, name))
        else:
            marks -= 1
            self.execute('UPDATE marks SET count=%s WHERE steamid="%s"'%(marks, steamid))
            
    def getMarks(self, steamid):
        marks = self.fetchone('SELECT count FROM marks WHERE steamid="%s"'%steamid)
        if marks:
            try:
                return marks[0]
            except:
                return marks
        return 0
        
    def updateName(self, steamid, name):
        oldname = self.fetchone('SELECT name FROM marks WHERE steamid="%s"'%steamid)
        if len(oldname):
            oldname = oldname[0]
            if name != oldname:
                self.execute('UPDATE marks SET name="%s" WHERE steamid="%s"'%(name, steamid))
                
        oldname = self.fetchone('SELECT name FROM mute WHERE steamid="%s"'%steamid)
        if len(oldname):
            oldname = oldname[0]
            if name != oldname:
                self.execute('UPDATE mute SET name="%s" WHERE steamid="%s"'%(name, steamid))
                
    def getList(self):
        raw = self.fetchall('SELECT * FROM marks')
        #raw = [ [ steamid, name, count], ...]
        out = {}
        for i in raw:
            steamid, name, count = i
            out[steamid] = {'marks': count, 'mute':0}
            
        raw = self.fetchall('SELECT * FROM mute')
        for i in raw:
            steamid, name, count = i
            if steamid in out:
                out[steamid]['mute'] = count
            else:
                out[steamid] = {'marks': 0, 'mute':count}
                
        return out
    
    def getInfo(self, steamid):
        return (self.getName(steamid), self.getMarks(steamid), self.getMuteMarks(steamid))
        
database = Database()

killCount = {}

cVotes_fk = {}# {freekiller_steam: [steamvote1, steamvote2, ....], .....}
cVotes_m  = {} # {notemute_steam: [steamvote1, steamote2, ....], ....}


def msg(text):
    es.msg('#multi', '#green[FreeKiller]#lightgreen ' + text)
    
def tell(userid, text):
    es.tell(userid, '#multi', '#green[FreeKiller]#lightgreen ' + text)
    
def load():
    cmdlib.registerSayCommand('!freekiller', cmd_freekill, 'Start a vote to mark a player as a freekiller')
    cmdlib.registerSayCommand('voteban', cmd_freekill, 'Start a vote to mark a player as a freekiller')
    cmdlib.registerSayCommand('votekick', cmd_freekill, 'Start a vote to mark a player as a freekiller')
    cmdlib.registerSayCommand('!votemute', cmd_votemute, 'Start a vote to mute a player')
    cmdlib.registerSayCommand('votemute', cmd_votemute, 'Start a vote to mute a player')
    cmdlib.registerSayCommand('!marks', cmd_marks, 'View your own marks, or as an admin view others marks')
    cmdlib.registerClientCommand('m_add', cmd_add, 'Add a steamid as a freekiller')
    advertLoop()
    mani_auth()
    msg('Loaded')
    
def unload():
    database.close(True)
    cmdlib.unregisterSayCommand('!freekiller')
    cmdlib.unregisterSayCommand('voteban')
    cmdlib.unregisterSayCommand('votekick')
    cmdlib.unregisterSayCommand('!votemute')
    cmdlib.unregisterSayCommand('votemute')
    cmdlib.unregisterSayCommand('!marks')
    cmdlib.unregisterClientCommand('m_add')
    gamethread.cancelDelayed('freekiller_advertloop')
    msg('Unloaded')
    
def advertLoop():
    if not activeVote:
        msg('Type !freekiller to vote someone a freekiller')
    gamethread.delayedname(30, 'freekiller_advertloop', advertLoop)
    
def es_map_start(ev):
    global cVotes_fk, cVotes_m
    database.commit()
    map_FreeKillers.clear()
    map_votemute.clear()
    cVotes_fk = {}
    cVotes_m = {}
    
def player_activate(ev):
    steamid = ev['es_steamid']
    marks = database.getMuteMarks(steamid)
    if marks >= 10:
        mute(ev['userid'])
        es.tell(userid, '#multi', '#green[VoteMute]#lightgreen You have been perm muted')
        
def player_spawn(ev):
    steamid = ev['es_steamid']
    
    if steamid in map_votemute and map_votemute[steamid] >= 2:
        mute(ev['userid'])

def player_death(ev):
    global killCount, cVotes_fk
    userid = ev['attacker']
    if int(userid) and es.getplayerteam(userid) == 3:
        ct = time.time()
        if userid in killCount:
            if killCount[userid]['time'] >= ct-graceTime:
                killCount[userid]['kills'] += 1
            else:
                killCount[userid]['time'] == ct
                killCount[userid]['kills'] = 1
        else:
            killCount[userid] = {'time': ct, 'kills': 1}
            
        if killCount[userid]['kills'] >= 3:
            name = ev['es_attackername']
            steamid = ev['es_attackersteamid']
            msg('%s#default is a possible freekiller#lightgreen (%s)'%(name, steamid))
            cVotes_fk[steamid] = {'name': name, 'votes': [], 'rcount':0}
            
            
def round_start(ev):
    killCount.clear()
    
def round_end(ev):
    global round_voted, cVotes_fk
    round_voted = []
    
    for steamid in list(cVotes_fk):
        cVotes_fk[steamid]['rcount'] += 1
        if cVotes_fk[steamid]['rcount'] > 3:
            del cVotes_fk[steamid]
            
    for steamid in list(cVotes_m):
        cVotes_m[steamid]['rcount'] += 1
        if cVotes_m[steamid]['rcount'] > 3:
            del cVotes_m[steamid]
    
    
def player_disconnect(ev):
    global killCount
    userid = ev['userid']
    if userid in killCount:
        del killCount[userid]
    
    #steam = es.getplayersteamid(userid)
    #if steam in cVotes_fk:
    #    del cVotes_fk[steam]
        
def player_team(ev):
	
    if ev['team'] == '3':
        userid = ev['userid']
        steamid = es.getplayersteamid(userid)
        if steamid in map_FreeKillers and map_FreeKillers[steamid] >= 2:
            gamethread.delayed(1, makeT, userid)
            tell(userid, 'You cannot be a CT until the next map')
        elif database.getMarks(es.getplayersteamid(userid)) >= 10:
            gamethread.delayed(1, makeT, userid)
            tell(userid, 'You cannot be a CT until the next map')
        else:
            tell(userid, 'Be sure that you do not freekill')
			
    #elif ev['team'] == '2':
    #    steamid = es.getplayersteamid(ev['userid'])
    #    if steamid in cVotes_fk:
    #        del cVotes_fk[steamid]
            
def makeT(userid):
    team = es.getplayerteam(userid)
    if team == 3:
        es.server.queuecmd('est_team %s 2'%userid)
        
def es_player_validated(ev):
    steamid = ev['networkid']
    if steamid in map_FreeKillers:
        if map_FreeKillers[steamid] >= 2:
            es.server.queuecmd('kickid %s "You are a FreeKiller - Wait until map change"'%ev['userid'])
            return
    
    if database.getMarks(steamid) >= 10:
        es.server.queuecmd('kickid %s "You are a FreeKiller"'%ev['userid'])
        
def cmd_freekill(userid, args):
    userid = int(userid)
    if popuplib.exists('freekiller_playerlist'): popuplib.delete('freekiller_playerlist')
    p = popuplib.easymenu('freekiller_playerlist', None, playerlist_handle)
    p.settitle('Select the FreeKiller')
    users = filter(lambda x: x != userid and es.getplayerteam(x) == 3, es.getUseridList())
    
    onlist = []
    
    for uid in users:
        name = es.getplayername(uid)
        steamid = es.getplayersteamid(uid)
        onlist.append(steamid)
        if steamid in cVotes_fk:
            p.addoption(steamid, '%s - %s Votes'%(name, len(cVotes_fk[steamid]['votes'])))
        else:
            p.addoption(steamid, '%s - 0 Votes'%name)
            
    for steamid in cVotes_fk:
        if not steamid in onlist:
            p.addoption(steamid, '%s - %s Votes'%(cVotes_fk[steamid]['name'], len(cVotes_fk[steamid]['votes'])))
    p.send(userid)
    
def cmd_votemute(userid, choice):
    userid = int(userid)
    sid = es.getplayersteamid(userid)
    pname = 'votemute_playerlist_%s'%userid
    if popuplib.exists(pname): popuplib.delete(pname)
    p = popuplib.easymenu(pname, None, playerlist_handle_mute)
    p.settitle('Select who to mute')
    
    onlist = []
    
    for uid in es.getUseridList():
        if userid != uid and es.getplayerteam(uid) == 2:
            name = es.getplayername(uid)
            steamid = es.getplayersteamid(uid)
            if steamid in cVotes_m:
                p.addoption(steamid, '%s - %s Votes'%(es.getplayername(uid), len(cVotes_m[steamid]['votes'])))
            else:
                p.addoption(steamid, '%s - 0 Votes'%es.getplayername(uid))
            onlist.append(steamid)
            
    for steamid in cVotes_m:
        if steamid != sid and not steamid in onlist:
            p.addoption(steamid, '%s - %s Votes'%(cVotes_m[steamid]['name'], len(cVotes_m[steamid]['votes'])))
            
    p.send(userid)
        
        
def playerlist_handle_mute(userid, choice, popupname):
    global cVotes_m, activeVote
    
    if popuplib.exists(popupname): popuplib.delete(popupname)
    
    usersteam = es.getplayersteamid(userid)
    username = es.getplayername(userid)
    targetname = es.getplayername(es.getuserid(choice))
    v = False
    
    if not choice in cVotes_m:
        cVotes_m[choice] = {}
        cVotes_m[choice]['votes'] = [usersteam]
        cVotes_m[choice]['name'] = targetname
        cVotes_m[choice]['rcount'] = 0
        v = True
    else:
        if usersteam in cVotes_m[choice]['votes']:
            tell(userid, 'You have already voted to mute that player')
        else:
            cVotes_m[choice]['votes'].append(usersteam)
            v = True
            
    playerc = len(es.getUseridList())
    if playerc <= 9:
        req = 3
    else:
        req = 5
            
    if len(cVotes_m[choice]['votes']) >= req and not activeVote:
        activeVote = VoteMute(choice)
    elif v:
        needed = req-len(cVotes_m[choice]['votes'])
        msg('%s has voted to mute %s. %s votes until votemute'%(username, cVotes_m[choice]['name'], needed))

def playerlist_handle(userid, choice, popupname):
    global cVotes_fk, activeVote
    usersteam = es.getplayersteamid(userid)
    username = es.getplayername(userid)
    ctname = es.getplayername(es.getuserid(choice))
    v = False
    if not choice in cVotes_fk:
        cVotes_fk[choice] = {}
        cVotes_fk[choice]['votes'] = [usersteam]
        cVotes_fk[choice]['name'] = ctname
        cVotes_fk[choice]['rcount'] = 0
        v = True
    else:
        if usersteam in cVotes_fk[choice]['votes']:
            tell(userid, 'You have already voted them as a freekiller')
        else:
            cVotes_fk[choice]['votes'].append(usersteam)
            v = True
            
            
    playerc = len(es.getUseridList())
    if playerc <= 9:
        req = 3
    else:
        req = 5
            
    if len(cVotes_fk[choice]['votes']) >= req and not activeVote:
        activeVote = FreeKillVote(choice)
    elif v:
        needed = req-len(cVotes_fk[choice]['votes'])
        msg('%s has voted %s a freekiller. %s votes until a freekiller vote.'%(username, cVotes_fk[choice]['name'], needed))
        
        
        
        
def mute(userid):
    if userid:
        steamid = es.getplayersteamid(userid)
        if steamid in mani_steams: return
        es.server.queuecmd('sm_mute #%s'%userid)
    
def unmute(userid):
    es.server.queuecmd('sm_unmute #%s'%userid)
    es.tell(userid, '#multi', '#green[VoteMute]#lightgreen You have been unmuted')
            
def getNeededVotes(currentVotes):
    playerc = float(len(es.getUseridList()))
    if currentVotes/playerc >= 0.6:
        return 0
        
    for x in range(currentVotes+1, int(playerc)+1):
        if x/playerc >= 0.6:
            return x-currentVotes
    
    return 'error'
    
def punish(steamid):
    userid = es.getuserid(steamid)
    name = es.getplayername(userid)
    
    if userid:
        playerlib.getPlayer(userid).slay()
    msg('%s has been voted to be a free killer!'%name)
    
    if steamid in map_FreeKillers:
        map_FreeKillers[steamid] += 1
    else:
        map_FreeKillers[steamid] = 1
        
    if map_FreeKillers[steamid] >= 2:
        if es.getplayerteam(userid) != 2:
            es.delayed(1, 'est_team %s 2'%userid)
            
        msg('%s cannot be a CT again this map!'%name)
                
    if name:
        database.addMark(steam, name)
    else:
        database.addMark(steam, 'Unknown')

def cmd_add(userid, args):
    steamid = es.getplayersteamid(userid)
    if isAdmin(steamid):
        if len(args) == 2:
            steamid, name = args[0], args[1]
            database.addSteam(steamid, name)
            tell(userid, 'Added %s (%s) as a freekiller'%(name, steamid))
        else:
            tell(userid, 'Invalid Syntax')
    else:
        tell(userid, 'You do not have access to that command')

def cmd_marks(userid, args):
    steamid = es.getplayersteamid(userid)
    if isAdmin(steamid):
        if popuplib.exists('freekill_adminlist'): popuplib.delete('freekill_adminlist')
        
        freekillers = database.getList()
        if freekillers:
            p = popuplib.easymenu('freekill_adminlist', None, showStats)
            p.settitle('FreeKillers')
            for steamid in freekillers:
                name = database.getName(steamid)
                marks = freekillers[steamid]['marks']
                mute = freekillers[steamid]['mute']
                p.addoption(steamid, '%s (%s), FK-%s,M-%s'%(name, steamid, marks, mute))
            p.send(userid)
        else:
            tell(userid, 'There are no records! :D')
        
    else:
        marks = database.getMarks(steamid)
        mute = database.getMuteMarks(steamid)
        if marks or mute:
            tell(userid, 'You have %s FreeKiller marks and %s mute marks'%(marks, mute))
        else:
            tell(userid, 'You have no marks against your name!')
            
def showStats(userid, steamid, popupname):
    if popuplib.exists(popupname):
        popuplib.delete(popupname)
    info = database.getInfo(steamid)
    if len(info) == 3:
        isOnline = es.getuserid(steamid)
        name, marks, mute = info
        if popuplib.exists('freekill_info'):
            popuplib.delete('freekill_info')
        p = popuplib.easymenu('freekill_info', None, player_handle)
        p.settitle('%s (%s)'%(name, steamid))
        if isOnline:
            p.addoption(('NA', steamid), 'Online', state=False)
        else:
            p.addoption(('NA', steamid), 'Offline', state=False)
        p.addoption(('NA', steamid), '%s FK Marks'%marks, state=False)
        p.addoption(('NA', steamid), '%s Mute Marks'%mute, state=False)
        p.addoption(('add', steamid), 'Add FK Mark')
        p.addoption(('sub', steamid), 'Subtract FK Mark')
        p.addoption(('madd', steamid), 'Add Mute Mark')
        p.addoption(('msub', steamid), 'Subtract Mute Mark')
        p.addoption(('del', steamid), 'Delete Player')
        if steamid in map_FreeKillers and map_FreeKillers[steamid] >= 2:
            p.addoption(('unres', steamid), 'Unrestrict T')
        else:
            p.addoption(('res', steamid), 'Restrict T')
        p.addoption(('back', steamid), 'Back to FreeKiller list')
        p.send(userid)
    else:
        tell(userid, 'An Error Occured [%s]'%steamid)
        cmd_marks(userid, [])
        
def player_handle(userid, given, popupname):
    global map_FreeKillers
    
    if popuplib.exists(popupname): popuplib.delete(popupname)
    
    choice, steamid = given
    
    if choice == 'add':
        database.addMark(steamid)
        showStats(userid, steamid, '')
    
    elif choice == 'madd':
        database.addMuteMark(steamid)
        showStats(userid, steamid, '')
        
    elif choice == 'sub':
        database.subMark(steamid)
        showStats(userid, steamid, '')
    
    elif choice == 'msub':
        database.subMuteMark(steamid)
        showStats(userid, steamid, '')
        
    elif choice == 'del':
        name, count, mute = database.getInfo(steamid)
        database.removeSteam(steamid)
        tell(userid, '%s (%s) was deleted'%(name, steamid))
        cmd_marks(userid, [])
    
    elif choice == 'back':
        cmd_marks(userid, [])
    
    elif choice == 'res':
        map_FreeKillers[steamid] = 2
        uid = es.getuserid(steamid)
        if uid and es.getplayerteam(uid) == 3:
            es.changeteam(uid, 2)
            tell(uid, 'You have been restricted to T')
        showStats(userid, steamid, '')
    
    elif choice == 'unres':
        if steamid in map_FreeKillers:
            del map_FreeKillers[steamid]
        showStats(userid, steamid, '')
        
    elif choice == 'NA':
        showStats(userid, steamid, '')
        
def isAdmin(steamid):
    return steamid in admins
        
def mani_auth():
    return
    clientsPath = str(es.ServerVar('eventscripts_gamedir')) + '/cfg/mani_admin_plugin/clients.txt'
    clientsFile = open(clientsPath, 'r')
    for line in clientsFile:
        list_line = line.split('"')
        if len(list_line) > 3:
            if list_line[3].startswith('STEAM_'):
                mani_steams.append(list_line[3])
    clientsFile.flush()
    clientsFile.close() 
mani_steams = []

        
        
        
        
